
files = ask('files to plot','*_sum')
filelist = findfile(files)
nfiles = n_elements(filelist)
if (nfiles gt 0 and strlen(filelist(0)) gt 0) then begin

  itime = intarr(6)
  tmp   = fltarr(11)
  data  = fltarr(1440*nfiles,11)
  time  = dblarr(1440*nfiles)
  line  = ''

  for ifile=0L,nfiles-1 do begin

    print, "Reading file ",filelist(ifile)
    openr,1,filelist(ifile)
    readf,1,line
    for i=0L,1440-1 do begin
      readf,1,itime,tmp
      c_a_to_r, itime, rtime
      data(ifile*1440L+i,*) = tmp
      time(ifile*1440L+i)   = rtime
    endfor
    close,1

  endfor

  stime = min(time)
  etime = max(time)

  time_axis, stime, etime, btr, etr, $
           xtickname, xtitle, xtickv, xminor, xtickn

  nhours = fix(ask('how many hours to average','1'))

  if nhours gt 0 then begin

    sph = 3600.0
    window = sph*nhours
    nt = 24*nfiles/nhours
    timeh = fltarr(nt)
    datah = fltarr(nt,11,4)

    for i=0,nt-1 do begin
      t = stime + i*window + window/2
      loc = where(time ge t-window/2 and time lt t+window/2, count)
      timeh(i) = t
      for j=0,10 do begin
        datah(i,j,0) = mean(data(loc,j))
        datah(i,j,1) = min(data(loc,j))
        datah(i,j,2) = max(data(loc,j))
        datah(i,j,3) = stddev(data(loc,j))
      endfor
    endfor

    timeh = timeh - stime

    plot, timeh, datah(*,0,0), xtickn = xtickname, xtitle = xtitle, $
        xtickv = xtickv, xminor = xminor, xticks = xtickn, xrange = [btr,etr]

    oplot, timeh, datah(*,0,1), linestyle = 1
    oplot, timeh, datah(*,0,2), linestyle = 1
    oplot, timeh, datah(*,0,3), linestyle = 2

  endif else begin

    time = time - stime

    plot, time, data(*,0), xtickn = xtickname, xtitle = xtitle, $
        xtickv = xtickv, xminor = xminor, xticks = xtickn

  endelse

endif

end
