
;--------------------------------------------------------------
; Get Inputs from the user
;--------------------------------------------------------------

amie_file = ask('AMIE binary file name','b931110.m.am')
amie_file2 = ask('AMIE binary file name','b931110.e')
psfile = ask('ps file',amie_file+'.ps')

ppp = 6

read_amie_binary, amie_file, data, lats, mlts, time, fields, 		$
                  imf, ae, dst, hp, cpcp

read_amie_binary, amie_file2, data2, lats2, mlts2, time2, fields2, 	$
                  imf2, ae2, dst2, hp2, cpcp2

ee = reform(data(0,5,*,*))
en = reform(data(0,6,*,*))

; use e-field from the other file!!

ee = reform(data2(0,5,*,*))
en = reform(data2(0,6,*,*))

je = reform(data(0,9,*,*))
jn = reform(data(0,10,*,*))
hall = reform(data(0,3,*,*))
ped = reform(data(0,1,*,*))

et = -en
ep = -ee
jt = -jn
jp = -je

e_total_2 = (et^2.0 + ep^2.0)

ped2 = (jp*ep + jt*et)/e_total_2
hall2 = ped2*0.0
loc = where(ep ne 0.0,count)
if (count gt 0) then hall2(loc) = (-jt(loc) + ped2(loc)*et(loc))/ep(loc)

loc = where(ped2 lt 0.0,count)
if count gt 0 then ped2(loc) = 0.0
loc = where(hall2 lt 0.0,count)
if count gt 0 then hall2(loc) = 0.0


ped_ped2 = ped-ped2

;ped = hall
;ped2 = hall2
hall_hall2 = hall-hall2

print, mm(ped2)


;ped = reform(data2(0,0,*,*))
;ped2 = reform(data(0,0,*,*))




;--------------------------------------------------------------
; figure out grid:
;--------------------------------------------------------------

nlats = n_elements(lats)
nmlts = n_elements(mlts)

lat2d = fltarr(nmlts,nlats)
lon2d = fltarr(nmlts,nlats)

for i=0,nlats-1 do lon2d(*,i) = mlts*!pi/12.0 - !pi/2.0
for i=0,nmlts-1 do lat2d(i,*) = lats

x = (90.0-lat2d)*cos(lon2d)
y = (90.0-lat2d)*sin(lon2d)

;--------------------------------------------------------------
; Determine maximum range
;--------------------------------------------------------------

mr = fix(max(90.0-lats)/10.0)*10.0 + 10.0

;--------------------------------------------------------------
; Set up device
;--------------------------------------------------------------

setdevice, psfile, 'l', 4, 0.95

;--------------------------------------------------------------
; Read color table. Blue to white to red for -/+ data,
; red to white for + only data.
;--------------------------------------------------------------

readct, ncolors, getenv("IDL_EXTRAS")+"jim6.ct"
clevels = (ncolors-1)*findgen(21)/20.0 + 1

levels = findgen(21)*1.
levels2 = levels-mean(levels)

;--------------------------------------------------------------
; Set up plot sizes for the circles
;--------------------------------------------------------------

space = 0.005
pos_space, ppp, space, sizes
total_plots = sizes.nby*sizes.nbx

;--------------------------------------------------------------
; determine how much slop we have for the color table.
;--------------------------------------------------------------

get_position, ppp, space, sizes, 0, pos
x_left = pos(0)
get_position, ppp, space, sizes, sizes.nbx-1, pos
x_right = pos(2)
slop = 1.0 - (x_right - x_left)

;--------------------------------------------------------------
; If there is too little room for the color table, we need
; to make a little more room.
;--------------------------------------------------------------

if (slop gt 0.02) then begin
  if (x_right lt 0.98) then shift_left = 0.0 				$
  else shift_left = 0.02 - (1.0-x_right)
  ct_left  = 0.98
  ct_right = 1.00
  d_shift_left = 0.0
endif else begin
  space = space*2.0
  pos_space, ppp, space, sizes
  get_position, ppp, space, sizes, 0, pos
  x_left = pos(0)
  get_position, ppp, space, sizes, sizes.nbx-1, pos
  x_right = pos(2)
  shift_left = x_left
  d_shift_left = space*0.5
  ct_right = 1.00
  ct_left  = ct_right - shift_left - d_shift_left*(sizes.nbx-1)
endelse

;--------------------------------------------------------------
; Determine the character size in normalized coordinates
;--------------------------------------------------------------

dy  = float(!d.y_ch_size)/float(!d.y_size)

;--------------------------------------------------------------
; If we have a whole bunch of plots, scale the size down.
;--------------------------------------------------------------

if (ppp gt 12) then ch_size = 0.65 else ch_size = 1.0

pn = 0
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, ped,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no06,/no00

  mini = min(ped)
  maxi = max(ped)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

pn = 1
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, ped2,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no00,/no06,/no18

  mini = min(ped2)
  maxi = max(ped2)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

pn = 2
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, ped_ped2,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels2, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no00,/no18

  mini = min(ped_ped2)
  maxi = max(ped_ped2)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

pn = 3
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, hall,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no06,/no12

  mini = min(hall)
  maxi = max(hall)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

pn = 4
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, hall2,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no12,/no06,/no18

  mini = min(hall2)
  maxi = max(hall2)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

pn = 5
get_position, ppp, space, sizes, pn, pos

;--------------------------------------------------------------
; Move over to the left a little bit for the color bar
;--------------------------------------------------------------

  pos([0,2]) = pos([0,2]) - shift_left - 				$
                            d_shift_left*float(pn mod sizes.nbx)

;--------------------------------------------------------------
; Color the back ground first
;--------------------------------------------------------------

  contour, hall_hall2,x,y,/follow, 			$
	xstyle = 5, ystyle = 5,						$
	xrange = [-mr,mr],yrange=[-mr,mr], levels = levels2, 		$
	pos = pos, /noerase, /cell_fill, c_color = clevels

  plotmlt, mr,/no12,/no18

  mini = min(hall_hall2)
  maxi = max(hall_hall2)

  mini_string = 'Min:'+tostr(round(mini))
  maxi_string = 'Max:'+tostr(round(maxi))
  up_shift    = 0.5*dy

  xyouts, pos(0), pos(1)+up_shift, mini_string, /norm, 			$
          charsize = 0.8*ch_size
  xyouts, pos(2), pos(1)+up_shift, maxi_string, /norm, 			$
          alignment=1.0, charsize = 0.8*ch_size

;--------------------------------------------------------------
; Plot the color bar if we need it.
;--------------------------------------------------------------

  if (pn+1 eq ppp) then begin
    ctpos = [ct_left, pos(1), ct_right, pos(3)]
    plotct, ncolors, ctpos, mm(levels), units, /right
  endif

closedevice

end




