
pro fit, x, y, slope, int, err, iter = iter

  if (n_elements(iter) eq 0) then iter = 1000

  if (n_elements(slope) gt 0) then slope_s = slope(0) else slope_s = 1.0
  if (n_elements(int) gt 0) then int_s = int(0) else int_s = 1.0

  test = x*slope_s + int_s
  err_s = sqrt(mean((y-test)^2))

  for n=1,iter do begin

    frac = 2.0
    if (n gt   iter/4) then frac = frac/2.0
    if (n gt   iter/2) then frac = frac/2.0
    if (n gt 3*iter/4) then frac = frac/2.0
    if (n gt 7*iter/8) then frac = frac/2.0

    slope = slope_s + (randomu(seed)-0.5)*2.0 * slope_s * frac
    int   = int_s   + (randomu(seed)-0.5)*2.0 *   int_s * frac

    test = x*slope + int
    err  = sqrt(mean((y-test)^2))

    if (err lt err_s) then begin
      err_s = err
      slope_s = slope
      int_s  = int
      print, n, slope_s, int_s, err_s
    endif

  endfor

  slope = slope_s
  int   = int_s
  err   = err_s

end
