
pro fit_sinl, goal, theta, offset, phase, amp, slope, error, iter = iter

  if (n_elements(iter) eq 0) then iter = 1000

  if (n_elements(offset) gt 0) then offset_s = offset(0) $
  else offset_s = mean(goal)
  if (n_elements(phase) gt 0) then phase_s = phase(0) else phase_s = !pi
  if (n_elements(amp) gt 0) then amp_s = amp(0) else amp_s = stddev(goal)
  if (n_elements(slope) gt 0) then slope_s = slope(0) $
  else slope_s = (goal(n_elements(goal)-1) - goal(0))/n_elements(goal)

  x = findgen(n_elements(goal))
  test = offset_s +sin(theta+phase_s)*amp_s + slope*x
  err_s = mean(abs(goal-test))

  for n=1,iter do begin

    frac = 2.0
    if (n gt   iter/4) then frac = frac/2.0
    if (n gt   iter/2) then frac = frac/2.0
    if (n gt 3*iter/4) then frac = frac/2.0
    if (n gt 7*iter/8) then frac = frac/2.0

    offset = offset_s + (randomu(seed)-0.5)*2.0 * offset_s * frac
    amp    = amp_s    + (randomu(seed)-0.5)*2.0 *    amp_s * frac
    phase  = phase_s  + (randomu(seed)-0.5)*2.0 *  phase_s * frac
    slope  = slope_s  + (randomu(seed)-0.5)*2.0 *  slope_s * frac

    test = offset +sin(theta+phase)*amp + slope*x
    err = mean(abs(goal-test))

    if (err lt err_s) then begin
      err_s = err
      offset_s = offset
      phase_s = phase
      amp_s = amp
      slope_s = slope
      print, n, offset_s, phase_s, amp_s, slope_s, err_s
    endif

  endfor

  error  = err_s
  offset = offset_s
  phase  = phase_s
  amp    = amp_s
  slope  = slope_s

end
