pro plot_data_loc, namiein, date, time, dt, minlat, nodata=nodata, ut=ut

  if n_elements(nodata) eq 0 then nodata = 0 else nodata = 1

  scale_nt = 25.0
  scale_mv = 3.0

  mr = 90.0 - minlat

  if n_elements(ut) eq 0 then begin

    sdate = strmid(date,4,2)+'-'+strmid(date,0,3)+'-'+strmid(date,10,2)+' '
    sdate = sdate + strmid(time,0,5)

    c_s_to_a, itime, sdate
    c_a_to_r, itime, rtime

  endif else rtime = ut

  stime = rtime - dt
  etime = stime + 2.0*dt

  openr,11,namiein

  line = ''
  for i=1,4 do readf,11,line

  files =intarr(6)

  readf,11,files

  skip = files(0) + files(1) + files(2) + 1

  for i=1,skip do readf,11,line

  data_dir = ''

  if (files(2) gt 0) then begin
    data_dir = line
    readf,11,line
  endif else readf,11,data_dir

  if (files(2) gt 0) then begin
    magfile = data_dir + strmid(line,8,16)
    magfile = strcompress(magfile,/remove_all)
  endif

  itime = intarr(6)
  latlon = fltarr(3)
  kloc = 0
  ang1n = 0.0
  en = 0.0
  ee = 0.0
  estring = ''

  t = findgen(10)*2.0*!pi/9
  r = 0.5
  usersym,r*cos(t),r*sin(t)

  psym = [8,4]

  for k=0,1 do begin

    for i=0,files(3+k)-1 do begin

      readf,11,line

      line = strcompress(line)
 
      for j=0,5 do line = strmid(line, strpos(line,' ')+1,strlen(line))
      filein = strmid(line,0,strpos(line,' '))

      print,"Searching file : ",filein

      filein = data_dir + filein

      openr,12,filein
      readf,12,line
      readf,12,line
      if (strpos(line,'year') lt 0) then readf,12,line

      done = 0

      while (not done) do begin

        readf,12,itime,latlon,kloc,ang1n,estring,			$
              format = '(I4,5I3,F6.2,F7.2,F6.2,I5,F7.2,A21)'
        c_a_to_r,itime, uttime

        if (uttime ge stime) and 					$
           (uttime le etime) and 					$
           (latlon(0) gt minlat) then begin
	  t = latlon(2)*2.0*!pi/24.0 - !pi/2
	  r = 90.0 - latlon(0)

          x0 = r*cos(t)
          y0 = r*sin(t)

          plots, [x0], [y0], psym = psym(k)

          ee = float(strmid(estring,0,7))
          ens = strcompress(strmid(estring,14,7))
          if strlen(ens) gt 1 then en = float(ens) else en = 0.0

          theta = (2.0*!pi - t) mod (2.0*!pi)
          d = (ee^2.0 + en^2.0)^0.5

; want pure north (h) to be 0 degrees, and rotate clock wise is positive

          phi = -1.0*asin(ee/d)
	  if (en lt 0.0) then phi = !pi - phi

          phi = phi - ang1n*!pi/180.0

          phi = !pi + (phi - theta)

          phi = phi + !pi

          xp = x0 + d*cos(phi)/scale_mv
          yp = y0 + d*sin(phi)/scale_mv

          if nodata eq 0 then plots, [x0,xp], [y0,yp]

        endif
        if (uttime gt etime) then done = 1
        if (eof(12)) then done = 1
      endwhile

      close,12

    endfor

  endfor

  done = 0
  cnt = 0

  while (not done) do begin
    readf,11,line
    if eof(11) then done = 1
    if (strpos(line, '&') ge 0) then cnt = cnt + 1
    if cnt eq 4 then done = 1
  endwhile

  t = findgen(10)*2.0*!pi/9
  r = 0.5
  usersym,r*cos(t),r*sin(t),/fill

  if (files(2) gt 0) then begin

    if (not eof(11)) then begin
      readf,11,line
      nstat = fix(strmid(line,0,3))
      readf,11,line
      lat = fltarr(nstat)
      lon = fltarr(nstat)
      sta = strarr(nstat)
      n = 0
      for i=0,nstat-1 do begin
        readf,11,line
        lat(n) = 90.0-float(strmid(line,36,6))
        lon(n) = float(strmid(line,42,7))*!pi/180.0
        sta(n) = strmid(line,4,3)
        n = n + 1 
      endfor

      lat = lat(0:n-1)
      lon = lon(0:n-1)
      sta = sta(0:n-1)

      c_r_to_a, itime, stime+dt
      h = float(itime(3))*60.0
      m = (float(itime(4))+h - 4.0*60.0 - 47.0)/4.0 * !pi/180.0

      lon = lon + m - !pi/2.0

      xpos = lat*cos(lon)
      ypos = lat*sin(lon)

      xpos2 = xpos
      ypos2 = ypos

      stime = stime + dt

      openr,12, magfile

      done = 0
      total = 0

      while (not done) do begin
        readf,12,line
        itime(0) = fix(strmid(line,0,2))  
        itime(1) = fix(strmid(line,2,2))
        itime(2) = fix(strmid(line,4,2))  
        itime(3) = fix(strmid(line,7,2))  
        itime(4) = fix(strmid(line,9,2))
        itime(5) = 0
        c_a_to_r,itime, uttime
        if (uttime ge stime) and 				$
           (uttime le etime) then begin
          etime = uttime
          stat_test = strmid(line,12,3)
          i = -1
          found = 0
          j = 0
          while (i eq -1) and (j lt n) do begin
            if (sta(j) eq stat_test) then begin
              i = j
              found = 1
            endif
            j = j + 1
          endwhile
          if (i eq -1) then done = 1				$
          else begin

	    total = total + 1
	    if total eq n then done = 1

	    h = float(strmid(line,19,6))
	    e = float(strmid(line,25,6))

            if (abs(h) lt 2000.0) and (abs(e) lt 2000.0) and	$
	       (lat(i) lt mr) then begin

              theta = (2.0*!pi - lon(i)) mod (2.0*!pi)
              d = (h^2.0 + e^2.0)^0.5

; want pure north (h) to be 0 degrees, and rotate clock wise is positive

              phi = -1.0*asin(e/d)
	      if (h lt 0.0) then phi = !pi - phi

              phi = !pi + (phi - theta)

; want to rotate counter clock wise 90 deg to the direction of convection

              phi = phi + !pi/2.0

              xpos2(i) = xpos(i) + d*cos(phi)/scale_nt
              ypos2(i) = ypos(i) + d*sin(phi)/scale_nt

              plots, [xpos(i)], [ypos(i)], psym = 8
;              if nodata eq 0 then 
	plots, [xpos(i),xpos2(i)], [ypos(i),ypos2(i)]

            endif

          endelse

        endif

      endwhile

; plot scale

      if nodata eq 0 then begin

        xnt = 0.0
        ynt = -100.0

        x0 = mr
        y0 = mr

        plots, [x0], [y0], psym = 8
        plots, [x0,x0+xnt/scale_nt], [y0,y0+ynt/scale_nt]

        xyouts, mr-2.0, mr-2.0, '100 nT', alignment = 1.0, charsize = 0.6

      endif

    endif

    close,12

  endif

  close,11

  return

end

