

amie_file = ask('AMIE binary file name','b.x1.m.uvi.r1.121')

psfile = ask('ps file',amie_file+'.imf.ps')

read_amie_binary, amie_file, data, lats, mlts, time, fields, 		$
                  imf, ae, dst, hp, cpcp

stime = min(time)
etime = max(time)

time_axis, stime, etime, s_time_range, e_time_range, 	$
	xtickname, xtitle, xtickvalue, xminor, xtickn

time = time - stime


setdevice, psfile, 'l', 4, 0.90

plotdumb

titles = ['IMF Bx (nT)','IMF By (nT)','IMF Bz (nT)','SW Vx (km/s)']

ppp = 4
space = 0.01
pos_space, ppp, space, sizes, ny = ppp

loc = where(abs(imf(*,0)) lt 100.0, count)
if count gt 0 then begin
  range = fltarr(3)
  for i=0,2 do range(i) = max(imf(loc,i)) - min(imf(loc,i))
  range = max(range)*1.1
endif

for i=0,3 do begin

  if i ne 3 then begin

    maxi = max(imf(loc,i))
    mini = min(imf(loc,i))
    r = (range - (maxi-mini))/2.0
    yr = [mini - r, maxi + r]

    xt = ' '
    xtn = strarr(20) + ' '

  endif else begin

    yr = [min(imf(*,i)*0.95), max(imf(*,i)) + 20.0]

    xt = xtitle
    xtn = xtickname

  endelse

  get_position, ppp, space, sizes, i, pos, /rect

  plot, /noerase, time, imf(*,i), ytitle = titles(i), pos = pos, $
	yrange = yr, xstyle = 1, max_val = yr(1), linestyle = lines,	$
	xtickname = xtn, xtitle = xt, xtickv=xtickvalue,	$
	xminor = xminor, xticks = xtickn, ystyle = 1

  oplot, time, time*0.0, linestyle = 2

  ndays = etime/(24.0*3600.0)
  for d = 1,ndays-1 do oplot, [d*24.0*3600.0,d*24.0*3600.0],[-10000,10000]

endfor

end