
datafile = ask('datafile','b19970301_data')

psfile = ask('psfile name','nmags.ps')

list = findfile(datafile)
nfiles = n_elements(list)
if nfiles eq 1 then begin
  if (strlen(list(0)) eq 0) then begin
    print, "could not find file"
    stop
  endif
endif

npts_total = 1440L
npts_total = npts_total * nfiles

time  = dblarr(npts_total)
nahn  = fltarr(npts_total)
nmags = fltarr(npts_total)

npts = -1L

for nf = 0,nfiles-1 do begin

  openr, 11, list(nf)

  print, "reading file ",list(nf)

  line = ''
  itime = intarr(6)

  done = 0

  data = fltarr(8)

  while (done eq 0) do begin

    readf,11,line

    if eof(11) then done = 1

    if (strpos(line,'#TIME') gt -1) then begin
      npts = npts + 1
      readf,11,itime
      c_a_to_r, itime, rtime
      time(npts) = rtime
    endif    

    if (strpos(line,'#AHN') gt -1) then begin
      readf,11,n
      nahn(npts) = n

      for i=0,n-1 do begin
        readf,11,data
        if (data(2) gt 1.0e4) then nahn(npts) = nahn(npts) - 1
      endfor

    endif    

    if (strpos(line,'#MAG') gt -1) then begin
      readf,11,n
      nmags(npts) = n

      for i=0,n-1 do begin
        readf,11,data
        if (data(2) gt 1.0e4) then nmags(npts) = nmags(npts) - 1
      endfor

    endif    

    if eof(11) then done = 1

  endwhile

  close,11

endfor

if (npts lt npts_total-1) then begin
  time  = time(0:npts)
  nahn  = nahn(0:npts)
  nmags = nmags(0:npts)
endif

stime = time(0)
etime = time(npts) + 60.0

time = time - stime

time_axis, stime, etime, btr, etr, xtickname, xtitle, xtickv, xminor, xtickn

setdevice, psfile, 'p', 4, 0.80

plotdumb

ppp = 2
space = 0.01

pos_space, ppp, space, sizes, ny = ppp

get_position, ppp, space, sizes, 0, pos, /rect
pos(0) = pos(0) + 0.075

plot, time, nmags, xstyle=1,			$
	ytitle = 'Number of E-Field Mags.',		$
	xtickname = strarr(20)+' ',			$
	xtitle = ' ',			$
	xtickv = xtickv,			$
	xminor = xminor,			$
	xticks = xtickn, xrange = [btr,etr],    $
	/noerase, ystyle = 1, yrange = [min(nmags)-2, max(nmags)+2], $
	pos=pos, charsize = 1.25

get_position, ppp, space, sizes, 1, pos, /rect
pos(0) = pos(0) + 0.075

plot, time, nahn, xstyle=1,			$
	ytitle = 'Number of Ahn Mags.',		$
	xtickname = xtickname,			$
	xtitle = xtitle,			$
	xtickv = xtickv,			$
	xminor = xminor,			$
	xticks = xtickn, xrange = [btr,etr],    $
	/noerase, ystyle = 1, yrange = [min(nahn)-2, max(nahn)+2], $
	pos=pos, charsize = 1.25

closedevice

end
