
common ffinfo, header

filelist = findfile('??/*.hed')
nfiles = n_elements(filelist)
filelist_master = filelist

statlist = [strmid(filelist(0),3,3)]
nstats = 1

for i=1,nfiles-1 do begin

  stat = strmid(filelist(i),3,3)

  ifound = 0
  istat = 0

  while (not ifound and istat lt nstats) do begin
    if (stat eq statlist(istat)) then ifound = 1
    istat = istat + 1
  endwhile

  if (not ifound) then begin
    statlist = [statlist,stat]
    nstats = nstats+1
  endif

endfor

; We need to get the latitude of the stations - so we have to read in the
; master.psi file

openr,1,'master.psi'
ns = 0
line = ''
readf,1,ns
readf,1,line
stations = strarr(ns)
lats     = fltarr(ns)
for i=0,ns-1 do begin
  readf,1,line
  stations(i) = mklower(strmid(line,4,3))
  lats(i)     = float(strmid(line,36,6))
endfor
close,1

maglats = fltarr(nstats)

for istat = 0,nstats-1 do begin

  loc = where(stations eq statlist(istat),count)

  if count gt 0 then latitude = lats(loc(0)) else begin
      print, 'working on station : ',statlist(istat),istat
      print, "Station not found!!!"
      latitude = 0.0
  endelse

;  print, "Station latitude : ", latitude
  maglats(iStat) = latitude

endfor

ind = sort(maglats)

itime = intarr(6)

nPtsMax = 1440

nStatsToProcess = nStats
nStatsToProcess = fix(ask('Number of stations to process',tostr(nStatsToProcess)))

if (nStatsToProcess eq 1) then begin 

    for istat = nstats-1, 0, -1 do begin

        iMag = ind(istat)
        lat = maglats(iMag)

        print, istat,'. ',statlist(ind(istat))

    endfor

    iStatStart = fix(ask('stat to process','0'))
    iStatEnd = iStatStart

endif else begin

;    fl = findfile('????01/*.remca')
;    iStatStart = nStats-n_elements(fl)
    iStatStart = nStats-1
    iStatEnd = 0

endelse

for istat = iStatStart, iStatEnd, -1 do begin

    iMag = ind(istat)
    lat = maglats(iMag)

    n = 0
    filelist = strarr(31)
    for i=0,nfiles-1 do begin
        if (strpos(filelist_master(i),statlist(ind(istat))) ge 0) then begin
            filelist(n) = filelist_master(i)
            n = n + 1
        endif
    endfor

    filelist = filelist(0:n-1)

    ndays = n_elements(filelist)

    print, "Station : ",statlist(ind(istat)), ndays

    for n=0,ndays-1 do begin
  
        print, filelist(n)

        itime(0) = fix(strmid(filelist(n),6,2))
        itime(1) = fix(strmid(filelist(n),8,2))
        itime(2) = fix(strmid(filelist(n),10,2))
        itime(3) = 0
        itime(4) = 0
        itime(5) = 0

        c_a_to_r, itime, stime

        itime(2) = itime(2) + 1
        c_a_to_r, itime, etime

        col_scal = [0,1,2]

        filename = strmid(filelist(n),0,12)
        print, "filename : ", filename

        read_flat_scalor, stime, etime, col_scal, time1f, data1f, nrows,     $
          filename = filename

        if (n eq 0) then begin
            data    = fltarr(3,nRows(0),ndays)
            time    = dblarr(nRows(0),ndays)
            dataqdr = fltarr(3,nRows(0),ndays) - 99999.0

            readhed, 1, filename, timeint, variables, units, 	$
              hedcount, hednrows, hedrowlen, vartype, heddata_struct
            components = $
              strmid(variables(0,0),3,1)+$
              strmid(variables(0,1),3,1)+$
              strmid(variables(0,2),3,1)
        endif

        if (n_elements(data(0,*,n)) eq n_elements(data1f(0,*))) then begin
            data(*,*,n) = data1f
            time(*,n)   = reform(time1f(0,*))
        endif else begin
            data(*,*,n) = -1.0e32
            time(*,n)   = time(0,n-1) + 24.0*3600.0 + $
              dindgen(n_elements(time(*,n)))*3600.0*24.0/n_elements(time(*,n))
        endelse

    endfor

    loc = where(abs(data) lt 70000,count)

    if (count gt 0) then begin

        despike_mags, data, time, lat, quality
        quiet_day, data, time, lat, quality, quietdata

        if (nRows(0) gt nPtsMax) then begin
            print, 'More that nPtsMax: ', nPtsMax
            average_mags, quietdata, time, lat, quality, nPtsMax, $
              averagedata, averagetime
        endif
        
    endif 

    loc = where(abs(quietdata) lt 70000,count)

    if (count gt 0) then begin

        if (iStat eq iStatStart) then begin

            if !d.name eq 'X' then setdevice,'stats.ps','l',4,0.95
  
            ppp = 3
            space = 0.01
            pos_space, ppp, space, sizes, ny = ppp
  
            get_position,ppp,space,sizes,0,pos1,/rect
            get_position,ppp,space,sizes,1,pos2,/rect
            get_position,ppp,space,sizes,2,pos3,/rect
            pos1(0) = pos1(0) + 0.05
            pos2(0) = pos2(0) + 0.05
            pos3(0) = pos3(0) + 0.05
  
            pos = fltarr(3,4)
            pos(0,*) = pos1
            pos(1,*) = pos2
            pos(2,*) = pos3
  
            stime_keep = min(time)
            c_r_to_a, itime, stime_keep
            itime(2) = 1
            itime(3) = 0
            itime(4) = 0
            itime(5) = 0
            c_a_to_r, itime, stime_keep

            if (itime(1) eq 1) then itime(2) = 31
            if (itime(1) eq 2) then itime(2) = 29
            if (itime(1) eq 3) then itime(2) = 31
            if (itime(1) eq 4) then itime(2) = 30
            if (itime(1) eq 5) then itime(2) = 31
            if (itime(1) eq 6) then itime(2) = 31
            if (itime(1) eq 7) then itime(2) = 30
            if (itime(1) eq 8) then itime(2) = 31
            if (itime(1) eq 9) then itime(2) = 30
            if (itime(1) eq 10) then itime(2) = 31
            if (itime(1) eq 11) then itime(2) = 30
            if (itime(1) eq 12) then itime(2) = 31
            itime(3) = 23
            itime(4) = 59
            itime(5) = 59
            c_a_to_r, itime, etime_keep
  
            time_axis, stime_keep, etime_keep, s_time_range, e_time_range, 	$
              xtickname, xtitle, xtickvalue, xminor, xtickn
  
;            comp = ['X','Y','Z']
  
        endif

        i = ind(istat)

        plotdumb

        for icomp = 0,2 do begin

            if (icomp eq 2) then begin
                xtn = xtickname
                xt  = xtitle
            endif else begin
                xtn = strarr(20)+' '
                xt  = ' '
            endelse

            title = ' '
            if (icomp eq 0) then $
              title =statlist(i)+' '+tostr(i+1)+'/'+tostr(istat)+' of '+tostr(nstats)

            plot, time-stime_keep,quietdata(icomp,*,*), pos = pos(icomp,*),	 $
              xstyle = 1, /noerase,		$
              xtickname = xtn, xtickv=xtickvalue, 			$
              xticks = xtickn, xminor = xminor, xtitle = xt,		$
              xrange = [s_time_range, e_time_range],                  $
              ytitle = strmid(components,icomp,1), $
              yrange = yrange, min_val = -5000.0, $
              title = title

            for iDay = 1, 31 do begin
                oplot, 3600.0*24*[iDay, iDay],[-5000,5000], linestyle = 1
            endfor

            oplot, [s_time_range, e_time_range], [0.0,0.0], linestyle = 1

            loc = where(quietdata(icomp,*,*) gt -5000.0,count)
            if (count gt 0) then m = median(quietdata(icomp,loc)) else m = -99999.

            ms = strcompress(string(m))

            xyouts, pos(icomp,2)+0.02, pos(icomp,1), ms, orient = 90, /norm

        endfor

        loc = where(quietdata lt -1.0e6,count)
        if count gt 0 then quietdata(loc) = -99999.0

        for n1 = 0, ndays-1 do begin
            c_r_to_a, itime, time(0,n1)
            ymd = chopr('0'+tostr(itime(0)),2)+ $
              chopr('0'+tostr(itime(1)),2)+ $
              chopr('0'+tostr(itime(2)),2)

            filename = ymd+'/'+mklower(statlist(i))+ymd+'.remca'
            openw,1,filename, error = iError
            
            if (iError ne 0) then begin
                spawn, "mkdir "+ymd
                openw,1,filename
            endif
            
            for it=0,nptsmax-1 do begin
                c_r_to_a, itime, time(it,n1)
                printf,1,format='(5i2,a,1x,a,3f10.1)', $
                  itime(0) mod 100, itime(1), itime(2), itime(3), itime(4),$
                  statlist(i), components, $
                  quietdata(0,it,n1), quietdata(1,it,n1), quietdata(2,it,n1)
            endfor
            close,1
        endfor

    endif

endfor

closedevice

end
