
pro read_j4_data, j4file, J4Data, J4Time, GeoPos, MagPos, nPts

  openr,1,j4file

  ; Read in the Header
  line = ''
  readf,1,line
  readf,1,line
  readf,1,line

  nPts = 0
  nPtsMax = 1000
  J4Time = dblarr(nPtsMax)

  GeoPos = fltarr(3,nPtsMax)
  MagPos = fltarr(3,nPtsMax)
  J4Data = fltarr(6,nPtsMax)

  itime = intarr(6)

  ; Now Read in the data

  while not eof(1) do begin

    readf,1,line

    itime(0) = fix(strmid(line,0,5))
    itime(1) = 1
    itime(2) = fix(strmid(line,5,4))
    itime(3) = fix(strmid(line,9,3))
    itime(4) = fix(strmid(line,13,2))
    itime(5) = fix(strmid(line,16,5))

    c_a_to_r, itime, rtime
    J4Time(nPts) = rtime

    for i=0,2 do GeoPos(i,nPts) = float(strmid(line,20+i*7,7))
    for i=0,2 do MagPos(i,nPts) = float(strmid(line,43+i*7,7))
    for i=0,1 do J4Data(i,nPts) = float(strmid(line,66+i*11,11))
    J4Data(2,nPts) = float(strmid(line,88,7))
    for i=0,1 do J4Data(i+3,nPts) = float(strmid(line,96+i*11,11))
    J4Data(5,nPts) = float(strmid(line,118,7))

    nPts = nPts + 1

    if (nPts gt nPtsMax) then begin
      print, "Too many points in file.  Increase nPtsMax = 1000"
      nPts = nPts - 1
    endif

  endwhile

  close,1

  if (nPts gt 0) then begin
    J4Time = J4Time(0:nPts-1)
    J4Data = J4Data(*,0:nPts-1)
    GeoPos = GeoPos(*,0:nPts-1)
    MagPos = MagPos(*,0:nPts-1)

    ; Convert to usefull units:

    J4Data(1,*) = J4Data(1,*) * 1.602e-12 *   100.0*100.0
                             ;  eV to ergs  /cm2 to /m2 

  endif

;  J4Data(1,*) = J4Data(1,*) * 1.0e-6 * 1.0e-2; ergs to J and something else

  return

end
