
pro redistribute, data, timein, timeout, average = average, $
                  interpolate = interpolate

  if (n_elements(interpolate) eq 0) then interpolate = 0 else interpolate  = 1
  if (n_elements(average) eq 0) then average = 0 else average = 1

  if (average eq 0 and interpolate eq 0) then begin
    if (n_elements(timein) gt 2*n_elements(timeout)) then begin
      average = 1
    endif else interpolate = 1
  endif

  if (interpolate) then begin

    datanew = spline(timein, data, timeout)

  endif else begin

    nPts = n_elements(timeout)
    datanew = fltarr(nPts)

    i = 0
    t1 = timeout(i)
    t2 = (timeout(i+1) + timeout(i))/2.0
    loc = where(timein ge t1 and timein lt t2, count)
    if (count gt 0) then begin
      datanew(i) = mean(data(loc))
    endif else datanew(i) = mean(data)

    for i=1,nPts-2 do begin
      t1 = (timeout(i-1) + timeout(i))/2.0
      t2 = (timeout(i+1) + timeout(i))/2.0
      loc = where(timein ge t1 and timein lt t2, count)
      if (count gt 0) then begin
        datanew(i) = mean(data(loc))
      endif else datanew(i) = mean(data)
    endfor

    i = nPts-1
    t1 = (timeout(i-1) + timeout(i))/2.0
    t2 = timeout(i)
    loc = where(timein ge t1 and timein le t2, count)
    if (count gt 0) then begin
      datanew(i) = mean(data(loc))
    endif else datanew(i) = mean(data)

  endelse

  data = datanew

end
