
GetNewData = 1

if (n_elements(data) gt 0) then begin
    filelist_new = findfile("b0001_*.*ALL")
    nfiles_new = n_elements(filelist_new)
    if (nfiles_new eq 1) then begin
        filelist_new = findfile("????_*.dat")
        nfiles_new = n_elements(filelist_new)
    endif
;    filelist_new = findfile("????_*.dat")
    if (nfiles_new eq nfiles) then default = 'n' else default='y'
    GetNewData = mklower(strmid(ask('whether to reread data',default),0,1))
    if (GetNewData eq 'n') then GetNewData = 0 else GetNewData = 1
endif

if (GetNewData) then begin

    filelist = findfile("????_*.dat")
    ;filelist1 = findfile("????_00?_t*.dat")
    ;filelist2 = findfile("????_01?_t*.dat")
    ;filelist3 = findfile("????_02?_t*.dat")
    ;filelist = [filelist1, filelist2, filelist3]

    nfiles = n_elements(filelist)

    iSatPosStart = 5
    iSatPosLength = 3

    if (nfiles eq 1) then begin
        filelist = findfile("b0001_*.*ALL")
        nfiles = n_elements(filelist)
        iSatPosStart = 1
        iSatPosLength = 4
    endif

    iCurSat = 0
    iFile = 0

    nSats = 0
    sats    = strarr(100)
    nSwaths = intarr(100)
    nPts    = intarr(100,100)
    nPts(0,0) = 1
    
    sats(0) = strmid(filelist(0),0,4)
    
    n = 1
    for i=1,nFiles-1 do begin
        cFile = filelist(i)
        if (strpos(cFile, sats(nSats)) ne 0) then begin
            n = n + 1
            nSats = nSats + 1
            sats(nSats) = strmid(filelist(i),0,4)
        endif else begin
;        n = fix(strmid(cFile,5,3))
            if (n gt nSwaths(nSats)) then nSwaths(nSats) = n
            nPts(nSats,n-1) = nPts(nSats,n-1) + 1
        endelse
    endfor
    nSats = nSats + 1
    
    if (nSats gt 1) then begin
        for i=0,nSats-1 do print, tostr(i)+'. '+sats(i)
        if (n_elements(isat) eq 0) then isat = 0
        isat = fix(ask('satellite to plot',tostr(isat)))
    endif else isat = 0

    if (nSats gt 1) then begin
        nPtsSw = nSwaths(iSat)
    endif else nPtsSw = 1

    nTimes = max(npts(iSat,*))

    it = 0

    for i=0,nFiles-1 do begin

        cFile = filelist(i)

        if (strpos(cFile, sats(isat)) eq 0) then begin

            read_thermosphere_file, cFile, nvars_t, nalts_t, nlats_t, nlons_t, $
              vars_t, data_t, nBLKlat_t, nBLKlon_t, nBLK_t

            if (it eq 0) then begin
                data = fltarr(nPtsSw, nTimes, nvars_t, nalts_t)
                time = dblarr(nTimes)
            endif

            if (n ne fix(strmid(cFile,iSatPosStart,iSatPosLength))-1 and $
                nSats gt 1) then it = 0
            if (nSats gt 1) then $
              n = fix(strmid(cFile,iSatPosStart,iSatPosLength))-1 else n = 0

            data(n, it, *, *) = data_t(*,0,0,*)

            if (n eq 0) then begin
                iSP = iSatPosStart + iSatPosLength + 2
                itime = [ $
                          fix(strmid(cfile,iSP   ,2)), $
                          fix(strmid(cfile,iSP+ 2,2)), $
                          fix(strmid(cfile,iSP+ 4,2)), $
                          fix(strmid(cfile,iSP+ 7,2)), $
                          fix(strmid(cfile,iSP+ 9,2)), $
                          fix(strmid(cfile,iSP+11,2))]
                c_a_to_r, itime, rtime
                time(it) = rtime
            endif

            it = it + 1

        endif

    endfor

endif

Vars = vars_t

if (nSats eq 1) then begin

    nPts = nTimes

    Alts = reform(data(0,0:nPts-1,2,0:nAlts_t-1))/1000.0
    Lons = reform(data(0,0:nPts-1,0,0)) * 180.0 / !pi
    Lats = reform(data(0,0:nPts-1,1,0)) * 180.0 / !pi

    d = Lats - Lats(0)
    if (max(abs(d)) lt 1.0) then stationary = 1 else stationary = 0

    time2d = dblarr(nPts,nAlts_t)
    for i=0,nPts-1 do time2d(i,*) = time(i)- time(0)

    display, vars
    if (n_elements(iVar) eq 0) then iVar = 3
    iVar = fix(ask('variable to plot',tostr(iVar)))

    value = reform(data(0,0:nPts-1,iVar,0:nAlts_t-1))

    if (min(value) gt 0) then begin
        if (n_elements(an) eq 0) then an = 'y'
        an = ask('whether you would like variable to be alog10',an)
        if (strpos(mklower(an),'y') eq 0) then begin
            value = alog10(value)
            title = 'alog10('+vars(ivar)+')'
        endif else title = vars(ivar)
    endif else title = vars(ivar)

    if (stationary) then begin

        if (n_elements(alt1) eq 0) then alt1 = 200.0 else alt1 = alt1(0)
        if (n_elements(alt2) eq 0) then alt2 = 500.0 else alt2 = alt2(0)
        alt1 = float(ask('altitude of first cut', string(alt1)))
        alt2 = float(ask('altitude of first cut', string(alt2)))

        d = abs(alt1 - reform(Alts(0,*)))
        loc = where(d eq min(d))
        iAlt1 = loc(0)

        d = abs(alt2 - reform(Alts(0,*)))
        loc = where(d eq min(d))
        iAlt2 = loc(0)

    endif

    setdevice, 'test.ps', 'p', 5, 0.95

    makect, 'mid'

    ppp = 8
    space = 0.01
    pos_space, ppp, space, sizes, ny = ppp
    
    get_position, ppp, space, sizes, 4, pos1, /rect
    get_position, ppp, space, sizes, 7, pos2, /rect
    pos = [pos1(0)+0.05,pos2(1), pos1(2)-0.07,pos1(3)]

    mini = min(value)
    maxi = max(value)
    range = (maxi-mini)
    mini = mini - 0.1*range
    maxi = maxi + 0.1*range
    levels = findgen(31) * (maxi-mini) / 30 + mini

    stime = time(0)
    etime = max(time)
    time_axis, stime, etime,btr,etr, xtickname, xtitle, xtickv, xminor, xtickn
    xtitle = strmid(xtitle,0,12)

    contour, value, time2d, Alts, /follow, /fill, $
      nlevels = 30, pos = pos, levels = levels, $
      yrange = [0,max(alts)], ystyle = 1, ytitle = 'Altitude (km)', $
      xtickname = xtickname, xtitle = xtitle, xtickv = xtickv, $
      xminor = xminor, xticks = xtickn, xstyle = 1

    if (stationary) then begin

        oplot, [time2d(0,0),time2d(nPts-1,0)], [Alts(0,iAlt1),Alts(0,iAlt1)], $
          linestyle = 1

        oplot, [time2d(0,0),time2d(nPts-1,0)], [Alts(0,iAlt2),Alts(0,iAlt2)], $
          linestyle = 1

    endif

    ctpos = pos
    ctpos(0) = pos(2)+0.01
    ctpos(2) = ctpos(0)+0.03
    maxmin = [mini,maxi]
    plotct, 255, ctpos, maxmin, title, /right

; Put the max and min on the plot

    mini_tmp = min(value)
    maxi_tmp = max(value)

    r = (maxi_tmp - mini_tmp)/50.0

    plots, [0.0,1.0], [mini_tmp, mini_tmp], thick = 5
    plots, [1.0,0.6], [mini_tmp, mini_tmp+r], thick = 2
    plots, [1.0,0.6], [mini_tmp, mini_tmp-r], thick = 2

    plots, [0.0,1.0], [maxi_tmp, maxi_tmp], thick = 5
    plots, [1.0,0.6], [maxi_tmp, maxi_tmp+r], thick = 2
    plots, [1.0,0.6], [maxi_tmp, maxi_tmp-r], thick = 2

    get_position, ppp, space, sizes, 3, pos1, /rect
    pos = [pos1(0)+0.05,pos1(1), pos1(2)-0.07,pos1(3)]

    if (not stationary) then begin

        plot, time-stime, Lons, ytitle = 'Longitude', /noerase, $
          xtickname = strarr(10)+' ', xtickv = xtickv, $
          xminor = xminor, xticks = xtickn, xstyle = 1, pos = pos, $
          yrange = [0.0,360.0], ystyle = 1, thick = 3
  
        get_position, ppp, space, sizes, 2, pos1, /rect
        pos = [pos1(0)+0.05,pos1(1), pos1(2)-0.07,pos1(3)]

        plot, time-stime, Lats, ytitle = 'Latitude', /noerase, $
          xtickname = strarr(10)+' ', xtickv = xtickv, $
          xminor = xminor, xticks = xtickn, xstyle = 1, pos = pos, $
          yrange = [-90.0,90.0], ystyle = 1, thick = 3
  
    endif else begin

        mini = min(value(*, iAlt1))
        maxi = max(value(*, iAlt1))
        range = maxi-mini
        mini = mini - 0.02*range
        maxi = maxi + 0.02*range

        plot, time-stime, value(*, iAlt1), ytitle = title, /noerase, $
          xtickname = strarr(10)+' ', xtickv = xtickv, $
          xminor = xminor, xticks = xtickn, xstyle = 1, pos = pos, $
          thick = 3, yrange = [mini,maxi], ystyle = 1
  
        get_position, ppp, space, sizes, 2, pos1, /rect
        pos = [pos1(0)+0.05,pos1(1), pos1(2)-0.07,pos1(3)]

        mini = min(value(*, iAlt2))
        maxi = max(value(*, iAlt2))
        range = maxi-mini
        mini = mini - 0.02*range
        maxi = maxi + 0.02*range

        plot, time-stime, value(*,iAlt2), ytitle = title, /noerase, $
          xtickname = strarr(10)+' ', xtickv = xtickv, $
          xminor = xminor, xticks = xtickn, xstyle = 1, pos = pos, $
          thick = 3, yrange = [mini,maxi], ystyle = 1
  
    endelse

    get_position, ppp, space, sizes, 0, pos1, /rect
    get_position, ppp, space, sizes, 1, pos2, /rect
    pos = [pos1(0)+0.05,pos2(1), pos1(2)-0.07,pos1(3)]

    !p.position = pos

    map_set, /noerase
    map_continents, color = 0

    oplot, lons, lats, psym = 1

    xyouts, lons(0), lats(0), 'Start', charsize = 1.2
    xyouts, lons(nPts-1), lats(nPts-1), 'End', charsize = 1.2

    closedevice

endif else begin

    lons = reform(data(*,*, 0, 0))*180.0/!pi
    lats = reform(data(*,*, 1, 0))*180.0/!pi

    display, vars
    iVar = 3
    iVar = fix(ask('variable to plot',tostr(iVar)))

    iLevel = fix(ask('ilevel to plot','25'))

    alt = data(0,0,2,iLevel)/1000.0

    value_tmp = reform(data(*,*,iVar,iLevel))

    loc = where(lons gt 180,count)
    if count gt 0 then lons(loc) = lons(loc)-360.0

    for i = 0, nPtsSw-1 do begin
        for j = 2, nTimes-1 do begin
            if (abs(lons(i,j)-lons(i,j-1)) gt 10.0 and $
                abs(lons(i,j)+360.0-lons(i,j-1)) gt 10.0) then begin
                lons(i,j) = lons(i,j-1) + (lons(i,j-1)-lons(i,j-2))
                value_tmp(i,j) = value_tmp(i,j-1)
            endif
        endfor
    endfor

    value  = fltarr(nTimes,nPtsSw)
    for i=0,nPtsSw-1 do value(*,i) = value_tmp(i,*)

    time2d = dblarr(nTimes,nPtsSw)
    dummy  = fltarr(nTimes,nPtsSw)
    for i=0,nTimes-1 do time2d(i,*) = time(i)- time(0)
    for i=0,nTimes-1 do dummy(i,*)  = findgen(nPtsSw)

    if (min(value) gt 0) then begin
        an = ask('whether you would like variable to be alog10','y')
        if (strpos(mklower(an),'y') eq 0) then begin
            value_tmp = alog10(value_tmp)
            value = alog10(value)
            title = 'alog10('+vars(ivar)+')'
        endif else title = vars(ivar)
    endif else title = vars(ivar)

    setdevice, 'test.ps', 'p', 5, 0.95

    makect, 'mid'

    ppp = 8
    space = 0.01
    pos_space, ppp, space, sizes, ny = ppp
    
    get_position, ppp, space, sizes, 2, pos1, /rect
    get_position, ppp, space, sizes, 3, pos2, /rect
    pos = [pos1(0)+0.05,pos2(1), pos1(2)-0.07,pos1(3)]

    mini = min(value)
    maxi = max(value)
    range = (maxi-mini)
    mini = mini - 0.1*range
    maxi = maxi + 0.1*range
    levels = findgen(31) * (maxi-mini) / 30 + mini

    stime = time(0)
    etime = max(time)
    time_axis, stime, etime,btr,etr, xtickname, xtitle, xtickv, xminor, xtickn
    xtitle = strmid(xtitle,0,12)

    contour, value, time2d, dummy, /follow, /fill, $
      nlevels = 30, pos = pos, levels = levels, $
      ystyle = 1, ytitle = 'Swath', $
      xtickname = xtickname, xtitle = xtitle, xtickv = xtickv, $
      xminor = xminor, xticks = xtickn, xstyle = 1

    ctpos = pos
    ctpos(0) = pos(2)+0.01
    ctpos(2) = ctpos(0)+0.03
    maxmin = [mini,maxi]
    plotct, 255, ctpos, maxmin, title, /right

; Put the max and min on the plot

    mini_tmp = min(value)
    maxi_tmp = max(value)

    r = (maxi_tmp - mini_tmp)/50.0

    plots, [0.0,1.0], [mini_tmp, mini_tmp], thick = 5
    plots, [1.0,0.6], [mini_tmp, mini_tmp+r], thick = 2
    plots, [1.0,0.6], [mini_tmp, mini_tmp-r], thick = 2

    plots, [0.0,1.0], [maxi_tmp, maxi_tmp], thick = 5
    plots, [1.0,0.6], [maxi_tmp, maxi_tmp+r], thick = 2
    plots, [1.0,0.6], [maxi_tmp, maxi_tmp-r], thick = 2

    get_position, ppp, space, sizes, 0, pos1, /rect
    get_position, ppp, space, sizes, 1, pos2, /rect
    pos = [pos1(0)+0.05,pos2(1), pos1(2)-0.07,pos1(3)]

    !p.position = pos

    map_set, /noerase, title = Vars(iVar)+' at '+tostr(fix(alt))+' km'

    iEnd = 0
    Stop = 0
    while not Stop do begin

        if (max(abs(lons(*,iEnd))) gt 150.0) then begin
            if (max(lons(*,iEnd)) gt 150.0 and $
                min(lons(*,iEnd)) lt 0) then begin
                Stop= 1
                print, "lon stop"
            endif
        endif

        if (max(abs(lats(*,iEnd))) gt 80.0) then begin
            for i = 0, nPtsSw-1 do begin
                if (abs(lats(i,iEnd)) - abs(lats(i,iEnd+1)) lt 0) then begin
                    if (lons(i,iEnd+1) - lons(i,iEnd) gt 20) then begin
                        stop = 1
                        print, "Lat stop", iEnd
                    endif
                endif
            endfor
        endif

        if (not stop) then iEnd = iEnd +1

    endwhile
    iEnd = iEnd-1

;iEnd = nTimes
    contour, value_tmp(1:nPtsSw-2,0:iEnd-1), $
      lons(1:nPtsSw-2,0:iEnd-1), lats(1:nPtsSw-2,0:iEnd-1), $
      /over, /cell_fill, nlevels = 30, levels = levels

    contour, value_tmp(1:nPtsSw-2,iEnd+2:nTimes-1), $
      lons(1:nPtsSw-2,iEnd+2:nTimes-1), $
      lats(1:nPtsSw-2,iEnd+2:nTimes-1), $
      /over, /cell_fill, nlevels = 30, levels = levels

    map_continents, color = 0

    xyouts, lons(0,0), lats(0,0), 'Start', charsize = 1.2
    xyouts, lons(nPtsSw-1,nTimes-1), lats(nPtsSw-1,nTimes-1), 'End', $
      charsize = 1.2

    closedevice

endelse

!p.position = -1

end
