;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;+
; NAME:
;    jday_to_day_of_year
; PURPOSE:
;    Returns the day of the year [0,366] given the Julian Day input.
;-
function jday_to_day_of_year, jday

    ; Boiler plate
    compile_opt idl2 ; DEFINT32, strictarr, HIDDEN
    !warn.obs_routines = 1
    ; End Boiler plate

    caldat, jday, month, day, year, hour, minute, second
    
    day_of_year = fix( jday - julday( 1, 1, year, 0, 0, 0 ) + 1 )
    
    return, day_of_year
    
end

function test_jday_to_day_of_year

    ; Boiler plate
    compile_opt idl2 ; DEFINT32, strictarr, HIDDEN
    !warn.obs_routines = 1
    my_name = "test_jday_to_day_of_year"
    ; End Boiler plate

    success = 1

    if ( ~( 1 eq jday_to_day_of_year( julday( 1, 1, 1900, 0, 0, 0 ) ) ) ) then begin
        print, "FAILED Test 1: "+my_name
        success = 0
    endif else print, "PASSED Test 1"

    if ( ~( 366 eq jday_to_day_of_year( julday( 12, 31, 2000, 0, 0, 0 ) ) ) ) then begin
        print, "FAILED Test 2: "+my_name
        success = 0
    endif else print, "PASSED Test 2"

    return, success

end
