;+
; Converts Julian Day to seconds since UNIX Epoch (1970-01-01 00:00:00)
; 
; :Author: Rob Redmon, NOAA, 2009
;
; :Params:
;     jtime : in, required, type="double"
;     
; :Returns:
;     Seconds since 1970-01-01 00:00:00
;-
function jday_to_unix_time, jtime
    return, 86400D * ( jtime - julday( 1, 1, 1970, 0, 0, 0 ) )
end
