;+
; Boiler plate code.  Generally used at start of a routine
;     
; :Keywords:
;     NO_LOG: in, optional, type='boolean'
;     0 => Don't set up logger, 1 => init logger (no reset) if it is not already initialized
;     
;     VERBOSITY: in, optional, type='integer'
;         1: show {fatal}
;         2: show {fatal,error}
;         3: show {fatal,error,warn}
;         4: show {fatal,error,warn,info}
;         5: show all messages
;         unset: use existing debug level as default 
;-
pro ngdc_boiler, my_name, NO_LOG=NO_LOG, VERBOSITY=VERBOSITY

    compile_opt idl2 ; DEFINT32 strictarr
    !warn.obs_routines = 1

    if ( ~ keyword_set( NO_LOG ) ) then begin
        if ( n_elements( VERBOSITY ) eq 1 ) then logger, VERBOSITY=VERBOSITY $
        else                                     logger
    endif
    
end
