;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;+
; NAME:
;    Set_Intersection
; PURPOSE:
;    Converts array of 6 element time arrays to string.
; DESCRIPTION:
; CATEGORY:
;    Utility
; CALLING SEQUENCE:
;    pro timeArrayToString, time
; INPUTS:
;    time - e.g. [[2005, 1, 31, 12, 30, 0], [2003, 2, 28, 11, 14]] for "2005-1-31 12:30:0", "2003-2-28 11:14:0"
; OPTIONAL INPUT PARAMETERS:
; KEYWORD INPUT PARAMETERS:
; OUTPUTS:
; KEYWORD OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; MODIFICATION HISTORY:
;  2005-11-23  Written by Rob Redmon
;-
FUNCTION Set_Intersection, a, b
minab = Min(a, Max=maxa) > Min(b, Max=maxb) ;Only need intersection of ranges
maxab = maxa < maxb

   ; If either set is empty, or their ranges don't intersect: result = NULL.

IF maxab LT minab OR maxab LT 0 THEN RETURN, -1
r = Where((Histogram(a, Min=minab, Max=maxab) NE 0) AND  $
          (Histogram(b, Min=minab, Max=maxab) NE 0), count)

IF count EQ 0 THEN RETURN, -1 ELSE RETURN, r + minab
END
