; Computes the standard signum function for any list of values represented
; by the vector x.
; @author Rob Redmon
; @copyright NGDC, 2007
; @param   x {in}{required}{type=array value} Input vector whose signum is to be found.
; @returns y = signum( x )
function signum, x

    ; Boiler plate
    compile_opt idl2 ; DEFINT32, strictarr, HIDDEN
    !warn.obs_routines = 1
    ; End Boiler plate

    ; retain original data type
    y = 1 + 0*x
   
    loc_neg = where( x lt 0, count )
    if ( count gt 0 ) then y[loc_neg] = -1
   
    return, y
   
end
